


#include "cpp/v_cback.h"

class wxPlGridTable : public wxGridTableBase
{
    WXPLI_DECLARE_DYNAMIC_CLASS( wxPlGridTable );
    WXPLI_DECLARE_V_CBACK();
public:
    wxPlGridTable( const char* package )
        :m_callback( "Wx::GridTableBase" )
    {
        m_callback.SetSelf( wxPli_make_object( this, package ), true );
    }

    DEC_V_CBACK_INT__VOID( GetNumberRows );
    DEC_V_CBACK_INT__VOID( GetNumberCols );
    DEC_V_CBACK_BOOL__INT_INT( IsEmptyCell );
    DEC_V_CBACK_WXSTRING__INT_INT( GetValue );
    DEC_V_CBACK_VOID__INT_INT_WXSTRING( SetValue );
    DEC_V_CBACK_WXSTRING__INT_INT( GetTypeName );
    DEC_V_CBACK_BOOL__INT_INT_WXSTRING( CanGetValueAs );
    DEC_V_CBACK_BOOL__INT_INT_WXSTRING( CanSetValueAs );
    DEC_V_CBACK_LONG__INT_INT( GetValueAsLong );
    DEC_V_CBACK_DOUBLE__INT_INT( GetValueAsDouble );
    DEC_V_CBACK_BOOL__INT_INT( GetValueAsBool );
    // DEC_V_CBACK_VOIDP__INT_INT_WXSTRING( GetValueAsCustom );
    DEC_V_CBACK_VOID__INT_INT_LONG( SetValueAsLong );
    DEC_V_CBACK_VOID__INT_INT_DOUBLE( SetValueAsDouble );
    DEC_V_CBACK_VOID__INT_INT_BOOL( SetValueAsBool );
    // DEC_V_CBACK_VOIDP_INT_INT_WXSTRING_VOIDP( SetValueAsCustom );
    DEC_V_CBACK_VOID__WXGRID( SetView );
    DEC_V_CBACK_WXGRID__VOID_const( GetView );
    DEC_V_CBACK_VOID__VOID( Clear );
    DEC_V_CBACK_BOOL__SIZET_SIZET( InsertRows );
    DEC_V_CBACK_BOOL__SIZET( AppendRows );
    DEC_V_CBACK_BOOL__SIZET_SIZET( DeleteRows );
    DEC_V_CBACK_BOOL__SIZET_SIZET( InsertCols );
    DEC_V_CBACK_BOOL__SIZET( AppendCols );
    DEC_V_CBACK_BOOL__SIZET_SIZET( DeleteCols );
    DEC_V_CBACK_WXSTRING__INT( GetRowLabelValue );
    DEC_V_CBACK_WXSTRING__INT( GetColLabelValue );
    DEC_V_CBACK_VOID__INT_WXSTRING( SetRowLabelValue );
    DEC_V_CBACK_VOID__INT_WXSTRING( SetColLabelValue );
};

DEF_V_CBACK_INT__VOID_pure( wxPlGridTable, wxGridTableBase, GetNumberRows );
DEF_V_CBACK_INT__VOID_pure( wxPlGridTable, wxGridTableBase, GetNumberCols );
DEF_V_CBACK_BOOL__INT_INT_pure( wxPlGridTable, wxGridTableBase, IsEmptyCell );
DEF_V_CBACK_WXSTRING__INT_INT_pure( wxPlGridTable, wxGridTableBase, GetValue );
DEF_V_CBACK_VOID__INT_INT_WXSTRING_pure( wxPlGridTable, wxGridTableBase, SetValue );
DEF_V_CBACK_WXSTRING__INT_INT( wxPlGridTable, wxGridTableBase, GetTypeName );
DEF_V_CBACK_BOOL__INT_INT_WXSTRING( wxPlGridTable, wxGridTableBase, CanGetValueAs );
DEF_V_CBACK_BOOL__INT_INT_WXSTRING( wxPlGridTable, wxGridTableBase, CanSetValueAs );
DEF_V_CBACK_LONG__INT_INT( wxPlGridTable, wxGridTableBase, GetValueAsLong );
DEF_V_CBACK_DOUBLE__INT_INT( wxPlGridTable, wxGridTableBase, GetValueAsDouble );
DEF_V_CBACK_BOOL__INT_INT( wxPlGridTable, wxGridTableBase, GetValueAsBool );
// DEF_V_CBACK_VOIDP__INT_INT_WXSTRING( wxPlGridTable, wxGridTableBase, GetValueAsCustom );
DEF_V_CBACK_VOID__INT_INT_LONG( wxPlGridTable, wxGridTableBase, SetValueAsLong );
DEF_V_CBACK_VOID__INT_INT_DOUBLE( wxPlGridTable, wxGridTableBase, SetValueAsDouble );
DEF_V_CBACK_VOID__INT_INT_BOOL( wxPlGridTable, wxGridTableBase, SetValueAsBool );
// DEF_V_CBACK_VOIDP_INT_INT_WXSTRING_VOIDP( wxPlGridTable, wxGridTableBase, SetValueAsCustom );
DEF_V_CBACK_VOID__WXGRID( wxPlGridTable, wxGridTableBase, SetView );
DEF_V_CBACK_WXGRID__VOID_const( wxPlGridTable, wxGridTableBase, GetView );
DEF_V_CBACK_VOID__VOID( wxPlGridTable, wxGridTableBase, Clear );
DEF_V_CBACK_BOOL__SIZET_SIZET( wxPlGridTable, wxGridTableBase, InsertRows );
DEF_V_CBACK_BOOL__SIZET( wxPlGridTable, wxGridTableBase, AppendRows );
DEF_V_CBACK_BOOL__SIZET_SIZET( wxPlGridTable, wxGridTableBase, DeleteRows );
DEF_V_CBACK_BOOL__SIZET_SIZET( wxPlGridTable, wxGridTableBase, InsertCols );
DEF_V_CBACK_BOOL__SIZET( wxPlGridTable, wxGridTableBase, AppendCols );
DEF_V_CBACK_BOOL__SIZET_SIZET( wxPlGridTable, wxGridTableBase, DeleteCols );
DEF_V_CBACK_WXSTRING__INT( wxPlGridTable, wxGridTableBase, GetRowLabelValue );
DEF_V_CBACK_WXSTRING__INT( wxPlGridTable, wxGridTableBase, GetColLabelValue );
DEF_V_CBACK_VOID__INT_WXSTRING( wxPlGridTable, wxGridTableBase, SetRowLabelValue );
DEF_V_CBACK_VOID__INT_WXSTRING( wxPlGridTable, wxGridTableBase, SetColLabelValue );

WXPLI_IMPLEMENT_DYNAMIC_CLASS( wxPlGridTable, wxGridTableBase );


